Package: groovy.lang

## [Java] Class GString

- groovy.lang.GString

- All Implemented Interfaces and Traits:
    Buildable, Comparable, CharSequence, Writable, Serializable

      public abstract class GString
      extends GroovyObjectSupport

  Represents a String which contains embedded values such as "hello there ${user} how are you?" which can be evaluated lazily. Advanced users can iterate over the text and values to perform special processing, such as for performing SQL operations, the values can be substituted for ? and the actual value objects can be bound to a JDBC statement. The lovely name of this class was suggested by Jules Gosnell and was such a good idea, I couldn't resist :)

  Authors:
    James Strachan

- - ### Field Summary

    Fields
    Modifiers | Name | Description
    --- | --- | ---
    `static GString` | `EMPTY` | A GString containing a single empty String and no values.
    `static Object[]` | `EMPTY_OBJECT_ARRAY` |
    `static String[]` | `EMPTY_STRING_ARRAY` |

  - ### Constructor Summary

    Constructors
    Constructor and description
    `GString (Object values)`
    `GString (Object[] values)`

  - ### Methods Summary

    Methods
    Type Params | Return Type | Name and description
    --- | --- | ---
    `` | `void` | `build(GroovyObject builder)`
    `` | `char` | `charAt(int index)`
    `` | `int` | `compareTo(Object that)`
    `` | `boolean` | `equals(Object that)`
    `` | `boolean` | `equals(GString that)`
    `` | `byte[]` | `getBytes()`
    `` | `byte[]` | `getBytes(String charset)`
    `` | `String[]` | `getStrings()`
    `` | `Object` | `getValue(int idx)`
    `` | `int` | `getValueCount()`
    `` | `Object[]` | `getValues()`
    `` | `int` | `hashCode()`
    `` | `Object` | `invokeMethod(String name, Object args)` Overloaded to implement duck typing for Strings so that any method that can't be evaluated on this object will be forwarded to the toString() object instead.
    `` | `int` | `length()`
    `` | `Pattern` | `negate()` Turns a String into a regular expression pattern
    `` | `GString` | `plus(GString that)`
    `` | `GString` | `plus(String that)`
    `` | `CharSequence` | `subSequence(int start, int end)`
    `` | `String` | `toString()`
    `` | `Writer` | `writeTo(Writer out)`

  - ### Inherited Methods Summary

    Inherited Methods
    Methods inherited from class | Name
    --- | ---
    `class GroovyObjectSupport` | `getMetaClass, getProperty, invokeMethod, setMetaClass, setProperty`
    `class Object` | `wait, wait, wait, equals, toString, hashCode, getClass, notify, notifyAll`

- - ### Field Detail

    - #### public static final GString EMPTY

      A GString containing a single empty String and no values.

    - #### public static final Object[] EMPTY_OBJECT_ARRAY

    - #### public static final String[] EMPTY_STRING_ARRAY

  - ### Constructor Detail

    - #### public GString(Object values)

    - #### public GString(Object[] values)

  - ### Method Detail

    - #### @Override public void build(GroovyObject builder)

    - #### @Override public char charAt(int index)

    - #### @Override public int compareTo(Object that)

    - #### @Override public boolean equals(Object that)

    - #### public boolean equals(GString that)

    - #### public byte[] getBytes()

    - #### public byte[] getBytes(String charset)

    - #### public String[] getStrings()

    - #### public Object getValue(int idx)

    - #### public int getValueCount()

    - #### public Object[] getValues()

    - #### @Override public int hashCode()

    - #### @Override public Object invokeMethod(String name, Object args)

      Overloaded to implement duck typing for Strings so that any method that can't be evaluated on this object will be forwarded to the toString() object instead.

    - #### @Override public int length()

    - #### public Pattern negate()

      Turns a String into a regular expression pattern

      Returns:
        the regular expression pattern

    - #### public GString plus(GString that)

    - #### public GString plus(String that)

    - #### @Override public CharSequence subSequence(int start, int end)

    - #### @Override public String toString()

    - #### @Override public Writer writeTo(Writer out)